// newratnum.cpp
// Winter 2002, 2nd quarter c++
// Implementation of class Ratnum
// To be completed for homework 7

#include <iostream>
#include "ratnum.h"
using std::cerr;
using std::endl;
using std::cout;

// rational number defaults to 0, if no denominator is passed, it
// is set to the integer n
Ratnum::Ratnum(int n, int d)
{
	set_ratnum(n, d);
}

// copy constructor
Ratnum::Ratnum(const Ratnum &r)
{
    set_ratnum(r.numerator, r.denominator);
}

inline int Ratnum::get_denominator() const
{
	return denominator;
}

inline int Ratnum::get_numerator() const
{
	return numerator;
}

bool Ratnum::set_ratnum(int n, int d)
{
    int divisor;
    if (d==0) return false;
    if (n==0) { numerator = 0; denominator =1; return true; }
    if (d < 0) {n=-n; d=-d;}
    divisor = gcd(n, d);
    numerator = n/divisor;
    denominator = d/divisor;
    return true;
}

double Ratnum::convert_to_double() const
{
	return static_cast <double> (numerator) / denominator;
}


// Does no error checking and requires the format a/b (even if b=1)
istream &operator>>(istream &input, Ratnum &right)
{
   int num, denom;
   char c;
   input >> num;
   c = input.get();  // input the character '/'
   input >> denom;
   right.set_ratnum(num, denom);
   return input;
}

bool Ratnum::operator==(const Ratnum &right) const
{
    return (right.numerator == numerator && right.denominator == denominator);
}

void swap(int &i1, int &i2)
{
    int temp;
    temp = i1;
    i1 = i2;
    i2 = temp;
}

int Ratnum::gcd(int a, int b)
{
    int r;
    if (a <0) a = -a;
    if (b <0) b = -b;
    if (b > a) swap(a,b); // make "a" be the bigger one
    if (b==0) return a;   // the gcd of a and 0 is a;
    while (a%b) {      // if b divides a, then b is the gcd, we're done
        r = a-(a/b)*b;  // r_n is the remainder when a is divided by b
        a = b;            // gcd(a,b) = gcd(b,r), so b is the new a
        b = r;          // and r is the new b
    }
    return b;
}


